package aexp.aidlclient;

import android.app.Activity;
import android.os.Bundle;
import android.os.IBinder;
import android.os.RemoteException;
import android.content.Intent;
import android.content.ComponentName;
import android.content.ServiceConnection;
import android.content.Context;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import aexp.aidl.IAdderService;

public class AIDLServiceClient extends Activity
{
    private IAdderService service;
    private AdderServiceConnection conn;

    class AdderServiceConnection implements ServiceConnection
    {
        public void onServiceConnected(ComponentName className, 
			IBinder boundService )
        {
          service = IAdderService.Stub.asInterface((IBinder)boundService);
		  Log.d( "ADDERSERVICECLIENT","onServiceConnected" );
        }

        public void onServiceDisconnected(ComponentName className)
        {
          service = null;
		  Log.d( "ADDERSERVICECLIENT","onServiceDisconnected" );
        }
    };

    /** Called with the activity is first created. */
    @Override
    public void onCreate(Bundle icicle)
    {
        super.onCreate(icicle);
        setContentView(R.layout.main);
		initService();
        Button invokeServiceButton = (Button) findViewById(R.id.invokeserv);
        invokeServiceButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                EditText aControl = (EditText)findViewById( R.id.A );
                String aString = aControl.getText().toString();
                EditText bControl = (EditText)findViewById( R.id.B );
                String bString = bControl.getText().toString();
                int a = 0,b = 0;
                String numberToEval = null;
                try {
                    numberToEval = aString;
                    a = Integer.parseInt( numberToEval );
                    numberToEval = bString;
                    b = Integer.parseInt( numberToEval );
			        invokeService( a,b );
                } catch( NumberFormatException ex ) {
	                TextView t = (TextView)findViewById(R.id.invokeserv_result);
                    t.setText( "Invalid number: "+numberToEval );
                }
     		}
        });
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
	    releaseService();
    }

	private void initService() {
	  conn = new AdderServiceConnection();
	  Intent i = new Intent();
	  i.setClassName( "aexp.aidl", "aexp.aidl.AdderServiceImpl" );
	  bindService( i, conn, Context.BIND_AUTO_CREATE);
	}

	private void releaseService() {
	  unbindService( conn );	  
	  conn = null;
	}

    private void invokeService( int i1, int i2 ) {
	  TextView t = (TextView)findViewById(R.id.invokeserv_result);
	  if( service == null )
		t.setText( "Service not available" );
	  else {
		try {
		  int result = service.add( i1,i2 );
		  t.setText( Integer.toString( result ) );
		} catch( RemoteException ex ) {
		  t.setText( "Service invocation error" );
		}
	  }
	}

}
